Option Explicit On 
Option Strict On
Option Compare Binary

Imports System

' <remarks>
'   Stellt Funktionen bereit, die in Verbindung mit 
'   Zugriffen auf das 32-Bit-Windows-API bentigt
'   werden.
' </remarks>
Public Class ApiHelper

    ' <summary>
    '   Gibt einen 32-Bit-Integer, der die niederwertigen 
    '   32 Bits von <paramref name="Value"/> enthlt, zurck.
    ' </summary>
    ' <param name="Value">Wert, dessen Low-Word berechnet werden soll.</param>
    ' <returns>Low-Word von <paramref name="Value"/>.</returns>
    Public Shared Function LOWORD(ByRef Value As Int32) As Int32
        Return Value And &HFFFF
    End Function

    ' <summary>
    '   Gibt einen 32-Bit-Integer, der die niederwertigen 32 
    '   Bits von <paramref name="Value"/> enthlt, zurck.
    ' </summary>
    ' <param name="Value">Wert, dessen Low-Word berechnet werden soll.</param>
    ' <returns>Low-Word von <paramref name="Value"/>.</returns>
    Public Shared Function LOWORD(ByRef Value As IntPtr) As Int32
        Return LOWORD(Value.ToInt32())
    End Function

    ' <summary>
    '   Gibt einen 32-Bit-Integer, der die hherwertigen 
    '   32 Bits von <paramref name="Value"/> enthlt, zurck.
    ' </summary>
    ' <param name="Value">Wert, dessen High-Word berechnet werden soll.</param>
    ' <returns>High-Word von <paramref name="Value"/>.</returns>
    Public Shared Function HIWORD(ByRef Value As Int32) As Int32
        If (Value And &H80000000) = &H80000000 Then
            Return ((Value And &H7FFF0000) \ &H10000) Or &H8000
        Else
            Return (Value And &HFFFF0000) \ &H10000
        End If
    End Function

    ' <summary>
    '   Gibt einen 32-Bit-Integer, der die hherwertigen
    '    32 Bits von <paramref name="Value"/> enthlt, zurck.
    ' </summary>
    ' <param name="Value">Wert, dessen High-Word berechnet werden soll.</param>
    ' <returns>High-Word von <paramref name="Value"/>.</returns>
    Public Shared Function HIWORD(ByRef Value As IntPtr) As Int32
        Return HIWORD(Value.ToInt32())
    End Function
End Class