Option Explicit On 
Option Strict On
Option Compare Binary

Imports System

' <remarks>
'   Hauptformular der Anwendung.
' </remarks>
Public Class MainForm
    Inherits System.Windows.Forms.Form

    Private Const WM_ACTIVATEAPP As Int32 = &H1C
    Private Const WM_ACTIVATE As Int32 = &H6

    Private Const WA_ACTIVE As Int32 = 1
    Private Const WA_CLICKACTIVE As Int32 = 2
    Private Const WA_INACTIVE As Int32 = 0

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents lstEvents As System.Windows.Forms.ListBox

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.lstEvents = New System.Windows.Forms.ListBox()
        Me.SuspendLayout()
        '
        'lstEvents
        '
        Me.lstEvents.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lstEvents.HorizontalScrollbar = True
        Me.lstEvents.Location = New System.Drawing.Point(16, 16)
        Me.lstEvents.Name = "lstEvents"
        Me.lstEvents.Size = New System.Drawing.Size(320, 238)
        Me.lstEvents.TabIndex = 0
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(352, 270)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lstEvents})
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "AppActivate"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)

        ' Prfen, ob sich der Fokus-Status unserer Anwendung verndert hat.
        Select Case m.Msg
            Case WM_ACTIVATEAPP
                If m.WParam.Equals(IntPtr.Zero) Then
                    AddMessage( _
                        "App deactivated - Thread getting focus: " & _
                        m.LParam.ToString())
                Else
                    AddMessage( _
                        "App activated - Thread losing focus: " & _
                        m.LParam.ToString())
                End If
            Case WM_ACTIVATE
                Dim s As String
                Select Case ApiHelper.LOWORD(m.WParam)
                    Case WA_ACTIVE
                        s = "Window activated by code - " & _
                            "Window losing focus: " & m.LParam.ToString()
                    Case WA_CLICKACTIVE
                        s = "Window activated by click - " & _
                            "Window losing focus: " & m.LParam.ToString()
                    Case WA_INACTIVE
                        s = "Window loses focus - " & _
                            "Window getting focus: " & m.LParam.ToString()
                End Select

                If ApiHelper.HIWORD(m.WParam) <> 0 Then
                    s = s & " and minimized"
                End If
                AddMessage(s)
        End Select
        MyBase.WndProc(m)
    End Sub

    Private Sub AddMessage(ByVal s As String)
        Me.lstEvents.Items.Add(s)
    End Sub
End Class